#include "COMMUnit.h"
#include <conio.h>
#include <stdio.h>

//Stores an incoming byte
char Incoming;
//Stores the user's keypress
char Key;

void main ()
{
  //Clear the screen
  clrscr ();

  //Open COM 2 with IRQ 3 at a speed of 28800 baud - change
  //this to match your settings
  COMOpenPort (2, 3, 28800);

  do {
    //If new data is available, display it on-screen
    if (COMReadByte (&Incoming)) printf ("%c", Incoming);
    //If a key has been pressed, handle it...
    if (kbhit ()) {
      //Retrieve the code
      Key = getch ();
      //Display on-screen
      printf ("%c", Key);
      //Write to the COM port
      COMWriteByte (Key);
      //If it was ENTER (actually, carriage return), we need to add Line Feed
      if (Key == 13) {
        printf ("%c", 10);
        COMWriteByte (10);
      }
    }
    //Continue until ESC was pressed
  } while (Key != 27);

  //Close the COM port
  COMClosePort ();
}